local vRP = Proxy.getInterface("vRP")

local pedList = {}
local cam = nil
local name = ''
local waitMore = true
local inMenu = false
local hasEntered = false


-- CREATE NPCs

Citizen.CreateThread(function()
	local pedInfo = {}
	local camCoords = nil
	local camRotation = nil

	for k, v in pairs(Config.TalkToNPC) do
		RequestModel(GetHashKey(v.npc))
		while not HasModelLoaded(GetHashKey(v.npc)) do
			Wait(1)
		end

		RequestAnimDict("mini@strip_club@idles@bouncer@base")
		while not HasAnimDictLoaded("mini@strip_club@idles@bouncer@base") do
			Wait(1)
		end

		ped =  CreatePed(4, v.npc, v.coordinates[1], v.coordinates[2], v.coordinates[3], v.heading, false, true)
		SetEntityHeading(ped, v.heading)
		FreezeEntityPosition(ped, true)
		SetEntityInvincible(ped, true)
		SetBlockingOfNonTemporaryEvents(ped, true)
		TaskPlayAnim(ped,"mini@strip_club@idles@bouncer@base","base", 8.0, 0.0, -1, 1, 0, 0, 0, 0)

		if Config.AutoCamPosition then
			local px, py, pz = table.unpack(GetEntityCoords(ped, true))
			local x, y, z = px + GetEntityForwardX(ped) * 1.2, py + GetEntityForwardY(ped) * 1.2, pz + 0.52

			camCoords = vector3(x, y, z)
		end

		if Config.AutoCamRotation then
			local rx = GetEntityRotation(ped, 2)

			camRotation = rx + vector3(0.0, 0.0, 181)
		end

		pedInfo = {
			name = v.name,
			model = v.npc,
			pedCoords = v.coordinates,
			entity = ped,
			camCoords = camCoords,
			camRotation = camRotation,
		}

		table.insert(pedList, pedInfo)
	end
end)

-- CHECK DISTANCE & JOB

Citizen.CreateThread(function()
	local inZone = false
	local hasSetName = false
	local nearPed = false
	local npcModel = nil
	local npcName = nil
	local npcKey = 0
	
	while true do
		Citizen.Wait(20)
		local playerCoords = GetEntityCoords(PlayerPedId())
		inZone = false
		nearPed = false
		if npcName == nil and npcModel == nil then
			for k,v in pairs(Config.TalkToNPC) do
				local distance = GetDistanceBetweenCoords(playerCoords.x, playerCoords.y, playerCoords.z, v.coordinates[1], v.coordinates[2], v.coordinates[3])
				if distance < v.interactionRange + 2 then
					npcName = v.name
					npcModel = v.npc
					npcKey = k
					nearPed = true
					if not inMenu then
						waitMore = false
					end
					
				elseif not waitMore and not nearPed then
					waitMore = true
				end
			end
		else
			v = Config.TalkToNPC[npcKey]
			if v ~= nil then
				local distance = GetDistanceBetweenCoords(playerCoords.x, playerCoords.y, playerCoords.z, v.coordinates[1], v.coordinates[2], v.coordinates[3])
				local zDistance = playerCoords.z - v.coordinates[3]
				if zDistance < 0 then
					zDistance = zDistance * -1
				end
				if zDistance < 2 then
					if distance < v.interactionRange + 3 then
						if not nearPed then
							nearPed = true
						end
						if not inMenu then
							waitMore = false
						end
						if distance < v.interactionRange then
							if not hasSetName then
								name = v.uiText
								hasSetName = true
							end
							if not inZone then
								inZone = true
							end
							if IsControlJustReleased(0, Config.Key) then

								inMenu = true
								waitMore = true
								StartCam(v.coordinates, v.camOffset, v.camRotation, v.npc, v.name)
								vRP.Close({})
								Citizen.Wait(500)
								if Config.HideMinimap then
									DisplayRadar(false)
								end
								SetNuiFocus(true, true)
								SendNUIMessage({
									action = 'openDialog',
									header = v.header,
									name = v.name,
									dialog = v.dialog,
									options = v.options,
									background = v.background,
								})
							end
						elseif hasSetName then
							hasSetName = false
						end
					elseif not waitMore and not nearPed then
						waitMore = true
					end
					if distance > v.interactionRange + 2 and npcName ~= nil and npcModel ~= nil then
						npcModel = nil
						npcName = nil
						npcKey = 0
					end
				end
			end
		end

		

		if inZone and not hasEntered then
			
			if Config.UseOkokTextUI then
				vRP.Open({'Vorbeste cu '..name}) 
			end
			hasEntered = true
		elseif not inZone and hasEntered then
			
			if Config.UseOkokTextUI then
				vRP.Close({})
			end
			hasEntered = false
		end 

		if waitMore then
			Citizen.Wait(1000)
		end
	end
end)

Citizen.CreateThread(function()
	local inZone = false
	while true do
		Citizen.Wait(0)
		local playerCoords = GetEntityCoords(PlayerPedId())
		inZone = false
		nearPed = false
		if npcName == nil and npcModel == nil then
			for k,v in pairs(Config.TalkToNPC) do
				local distance = GetDistanceBetweenCoords(playerCoords.x, playerCoords.y, playerCoords.z, v.coordinates[1], v.coordinates[2], v.coordinates[3])
				if distance < v.interactionRange + 2 then
					inzone = true
					Draw3DText(v.coordinates[1],v.coordinates[2],v.coordinates[3]+0.1,  "~w~Apasa ~r~[E] ~w~pentru a interactiona", 0.1, 0.1)
				end
				if not inzone then
				  Wait(1000)
				end
			end
		end
	end
 end)




-- ACTIONS

RegisterNUICallback('action', function(data, cb)
	if data.action == 'close' then
		SetNuiFocus(false, false)
		if Config.HideMinimap then
			DisplayRadar(true)
		end
		hasEntered = true
		EndCam()
		inMenu = false
		waitMore = false
	elseif data.action == 'option' then
		SetNuiFocus(false, false)
		if Config.HideMinimap then
			DisplayRadar(true)
		end
		hasEntered = true
		EndCam()
		inMenu = false
		waitMore = false

		if data.options[3] == 'c' then
			TriggerEvent(data.options[2])
		elseif data.options[3] ~= nil then
			TriggerServerEvent(data.options[2])
		end
	end
end)

-- CAMERA

function StartCam(coords, offset, rotation, model, name)
	ClearFocus()

	if Config.AutoCamRotation then
		for k,v in pairs(pedList) do
			if v.pedCoords == coords then
				if v.name == name and v.model == model then
					rotation = v.camRotation
				end
			end
		end
	end

	if Config.AutoCamPosition then
		for k,v in pairs(pedList) do
			if v.pedCoords == coords then
				if v.name == name and v.model == model then
					coords = v.camCoords
				end
			end
		end
	else
		coords = coords + offset
	end

	cam = CreateCamWithParams("DEFAULT_SCRIPTED_CAMERA", coords, rotation, GetGameplayCamFov())

	SetCamActive(cam, true)
	RenderScriptCams(true, true, Config.CameraAnimationTime, true, false)
end

function EndCam()
	ClearFocus()

	RenderScriptCams(false, true, Config.CameraAnimationTime, true, false)
	DestroyCam(cam, false)

	cam = nil
end

function Draw3DText(x,y,z,textInput,scaleX,scaleY)
	local px,py,pz=table.unpack(GetGameplayCamCoords())
	local dist = GetDistanceBetweenCoords(px,py,pz, x,y,z, 1)
	local scale = (1/dist)*20
	local fov = (1/GetGameplayCamFov())*100
	local scale = scale*fov
	SetTextScale(scaleX*scale, scaleY*scale)
	SetTextFont(4)
	SetTextProportional(1)
	SetTextDropshadow(1, 1, 1, 1, 255)
	SetTextEdge(2, 0, 0, 0, 150)
	SetTextDropShadow()
	SetTextOutline()
	SetTextEntry("STRING")
	SetTextCentre(1)
	AddTextComponentString(textInput)
	SetDrawOrigin(x,y,z+2, 0)
	DrawText(0.0, 0.0)
	ClearDrawOrigin()
end


-- function DrawTxt(text, x, y)
-- 	SetTextFont(0)
-- 	SetTextProportional(1)
-- 	SetTextScale(0.0, 0.4)
-- 	SetTextDropshadow(1, 0, 0, 0, 255)
-- 	SetTextEdge(1, 0, 0, 0, 255)
-- 	SetTextDropShadow()
-- 	SetTextOutline()
-- 	SetTextEntry("STRING")
-- 	AddTextComponentString(text)
-- 	DrawText(x, y)
-- end

-- Citizen.CreateThread(function()
--     while true do
-- 		Citizen.Wait(0)
-- 		local entity = IsPedInAnyVehicle(PlayerPedId()) and GetVehiclePedIsIn(PlayerPedId(), false) or PlayerPedId()
-- 		x, y, z = table.unpack(GetEntityCoords(entity, true))
		
-- 		roundx = tonumber(string.format("%.2f", x))
-- 		roundy = tonumber(string.format("%.2f", y))
-- 		roundz = tonumber(string.format("%.2f", z))
		
-- 		DrawTxt("~r~X:~s~ "..roundx, 0.32, 0.00)
-- 		DrawTxt("~r~Y:~s~ "..roundy, 0.38, 0.00)
-- 		DrawTxt("~r~Z:~s~ "..roundz, 0.445, 0.00)

-- 		heading = GetEntityHeading(entity)
-- 		roundh = tonumber(string.format("%.2f", heading))
-- 		DrawTxt("~r~H:~s~ "..roundh, 0.50, 0.00)

--         local rx,ry,rz = table.unpack(GetEntityRotation(PlayerPedId(), 1))
-- 		DrawTxt("~r~RX:~s~ "..tonumber(string.format("%.2f", rx)), 0.38, 0.03)
-- 		DrawTxt("~r~RY:~s~ "..tonumber(string.format("%.2f", ry)), 0.44, 0.03)
-- 		DrawTxt("~r~RZ:~s~ "..tonumber(string.format("%.2f", rz)), 0.495, 0.03)
	
-- 		speed = GetEntitySpeed(PlayerPedId())
-- 		rounds = tonumber(string.format("%.2f", speed))
-- 		DrawTxt("~r~Player Speed: ~s~"..rounds, 0.40, 0.92)

-- 		health = GetEntityHealth(PlayerPedId())
-- 		DrawTxt("~r~Player Health: ~s~"..health, 0.40, 0.95)

-- 		camRotX = GetGameplayCamRot().x
-- 		DrawTxt("~r~CR X: ~s~"..tonumber(string.format("%.2f", camRotX)), 0.36, 0.88)

-- 		camRotY = GetGameplayCamRot().y
-- 		DrawTxt("~r~CR Y: ~s~"..tonumber(string.format("%.2f", camRotY)), 0.44, 0.88)

-- 		camRotZ = GetGameplayCamRot().z
-- 		DrawTxt("~r~CR Z: ~s~"..tonumber(string.format("%.2f", camRotZ)), 0.51, 0.88)

-- 		veheng = GetVehicleEngineHealth(GetVehiclePedIsUsing(PlayerPedId()))
-- 		vehbody = GetVehicleBodyHealth(GetVehiclePedIsUsing(PlayerPedId()))
-- 		if IsPedInAnyVehicle(PlayerPedId(), 1) then
-- 			vehenground = tonumber(string.format("%.2f", veheng))
-- 			vehbodround = tonumber(string.format("%.2f", vehbody))

-- 			DrawTxt("~r~Engine Health: ~s~"..vehenground, 0.015, 0.76)

-- 			DrawTxt("~r~Body Health: ~s~"..vehbodround, 0.015, 0.73)

-- 			DrawTxt("~r~Vehicle Fuel: ~s~"..tonumber(string.format("%.2f", GetVehicleFuelLevel(GetVehiclePedIsUsing(PlayerPedId())))), 0.015, 0.70)
-- 		end
--     end
-- end)